pro momentanalysis

@varld.cb
common MOMAN_BLOCK,moments,TA,scf,scfl,scfs,scf0,filename1,titles1,filename2
common GUI_BLOCK
prog=intarr(2)
titles1=['Mean','Dispersion','Skewness','Kurtosis']
top=widget_base(/column,title='Data Analysis Window',xoffset=250,yoffset=250)
sideby=widget_base(top,/row)
	analyze1=widget_button(sideby,value='Analyze Normal Data',uvalue=1)
	analyze2=widget_button(sideby,value='Analyze Randomized Data',uvalue=2)

titles=widget_base(top,/row)
	block=widget_text(titles,value=' ',xsize=10)
	scft=widget_text(titles,value='S_ij',xsize=8)
	scflt=widget_text(titles,value='S^l_ij',xsize=8)
	scfst=widget_text(titles,value='S^s_ij',xsize=8)
	scf0t=widget_text(titles,value='S^0_ij',xsize=8)
base=widget_base(top,/row)
	titles=widget_text(base,value=titles1,ysize=4,xsize=10)
	scf=widget_text(base,value=transpose(strarr(4)),ysize=4,xsize=8)
	scfl=widget_text(base,value=transpose(strarr(4)),ysize=4,xsize=8)
	scfs=widget_text(base,value=transpose(strarr(4)),ysize=4,xsize=8)
	scf0=widget_text(base,value=transpose(strarr(4)),ysize=4,xsize=8)
base1=widget_base(top,/row)
	exp1=widget_button(base1,value='Export to LaTeX Table',uvalue=5)
	filename1=cw_field(base1,value='table.tex',title='File Name:')
base2=widget_base(top,/row)
	exp2=widget_button(base2,value='Export Full Table to Latex',uvalue=6)
	filename2=cw_field(base2,value='table2.tex',title='File Name:')
	bye=widget_button(top,value='Done.',uvalue=3)

widget_control,/realize,top

xmanager, 'momentanalysis', top 
end

;-----------------------

pro momentanalysis_event,event
common dev_block
common GUI_BLOCK
common MOMAN_BLOCK

widget_control, event.id, get_uvalue=buttonpress

if (buttonpress eq 3) then widget_control,event.top,/destroy

if (buttonpress eq 1) then begin
	moments=momentcube(outdata)
	moments=sigfigarr(moments,3)
	goto,display
endif

if (buttonpress eq 2) then begin
	if n_elements(outdata1) eq 0 then begin
		goback=widget_message(['You must first load',$
			'a randomized data cube.'])
		goto,skipout1
	endif
	moments=momentcube(outdata1)
	moments=sigfigarr(moments,3)
	goto,display
	skipout1:
endif
	
if (buttonpress lt 0) then begin
	display:
;	widget_control,TA,set_value=moments(*,8)
	widget_control,scf,set_value=moments(*,0)
	widget_control,scfl,set_value=moments(*,3)
	widget_control,scfs,set_value=moments(*,5)
	widget_control,scf0,set_value=moments(*,7)
endif

if (buttonpress eq 5) then begin
	if n_elements(moments) eq 0 then begin
		oops=widget_message('You must first calculate moments.')
		goto,skipout7
	endif
	widget_control,filename1,get_value=filenom
	openw,1,filenom(0)
	printf,1,'\documentclass{article}'
	printf,1,'\pagestyle{empty}'
	printf,1,'\begin{document}'
	printf,1,'\begin{table}[h]'
	printf,1,'\begin{center}
	printf,1,'\begin{tabular}{|c|c|c|c|c|}'
	printf,1,'\hline'
	printf,1,'& $S$ & $S^{l}$ & $S^s$ & $S^0$ \\ \hline '
	for i=0,3 do begin
		printf,1,titles1(i),' & ',moments(i,0),' & ',moments(i,3),$
		' & ', moments(i,5),' & ',moments(i,7),' \\'
		printf,1,'\hline'
	endfor
	printf,1,'\end{tabular}'
	printf,1,'\end{center}'
	printf,1,'\end{table}'
	printf,1,'\end{document}'
	close,1
	okay=widget_message('Data exported to file '+filenom(0),/information)
	skipout7:
endif

if (buttonpress eq 6) then begin
	if n_elements(moments) eq 0 then begin
		oops1=widget_message('You must first calculate moments.')
		goto,skipout8
	endif
	params=['$S$','$s$','$l$','$S^l$','$l^l$','$S^s$','$s$',$
	'$S^0$','$T_A$','$\Delta v$','$v_{LSR}$','$T_{int}$','$\sigma$',$
	'$T/\sigma$','$|l|$','$|l^l|$']
	widget_control,filename2,get_value=filenom
	openw,1,filenom(0)
	printf,1,'\documentclass{article}'
	printf,1,'\pagestyle{empty}'
	printf,1,'\begin{document}'
	printf,1,'\begin{table}[h]'
	printf,1,'\begin{center}
	printf,1,'\begin{tabular}{|c|c|c|c|c|}'
	printf,1,'\hline'
	printf,1,'& Mean & Dispersion & Skewness & Kurtosis \\ \hline '
	for i=0,15 do begin
	printf,1,params(i),' & ',moments(0,i), ' & ', moments(1,i),' & ',$
	moments(2,i), ' & ', moments(3,i), ' \\'
	printf,1,'\hline' 
	endfor
	printf,1,'\end{tabular}'
	printf,1,'\end{center}'
	printf,1,'\end{table}'
	printf,1,'\end{document}'
	close,1
	okay=widget_message('Data exported to file '+filenom(0),/information)
	skipout8:
endif
end





